package ssw.mj;

import java.io.PrintWriter;
import java.util.BitSet;

import ssw.mj.symtab.Obj;
import ssw.mj.symtab.Struct;
import ssw.mj.symtab.Tab;

/**
 * The parser for the MicroJava Compiler.
 */
public class Parser {

	private static final int
		none       = Token.none,
		ident      = Token.ident,
		number     = Token.number,
		charConst  = Token.charConst,
		plus       = Token.plus,
		minus      = Token.minus,
		times      = Token.times,
		slash      = Token.slash,
		rem        = Token.rem,
		eql        = Token.eql,
		neq        = Token.neq,
		gtr        = Token.gtr,
		geq        = Token.geq,
		less       = Token.less,
		leq        = Token.leq,
		and        = Token.and,
		or         = Token.or,
		assign     = Token.assign,
		pplus      = Token.pplus,
		mminus     = Token.mminus,
		semicolon  = Token.semicolon,
		comma      = Token.comma,
		period     = Token.period,
		lpar       = Token.lpar,
		rpar       = Token.rpar,
		lbrack     = Token.lbrack,
		rbrack     = Token.rbrack,
		lbrace     = Token.lbrace,
		rbrace     = Token.rbrace,
		classKW    = Token.classKW,
		continueKW = Token.continueKW,
		doKW       = Token.doKW,
		elseKW     = Token.elseKW,
		finalKW    = Token.finalKW,
		ifKW       = Token.ifKW,
		newKW      = Token.newKW,
		printKW    = Token.printKW,
		readKW     = Token.readKW,
		returnKW   = Token.returnKW,
		voidKW     = Token.voidKW,
		whileKW    = Token.whileKW,
		eof        = Token.eof;
	
	private static final String
		ADD_OP        = ErrorStrings.ADD_OP,
		ARRAY_INDEX   = ErrorStrings.ARRAY_INDEX,
		ARRAY_SIZE    = ErrorStrings.ARRAY_SIZE,
		CONST_DECL    = ErrorStrings.CONST_DECL,
		CONST_TYPE    = ErrorStrings.CONST_TYPE,
		DESIGN_FOLLOW = ErrorStrings.DESIGN_FOLLOW,
		INCOMP_TYPES  = ErrorStrings.INCOMP_TYPES,
		INVALID_DECL  = ErrorStrings.INVALID_DECL,
		INVALID_FACT  = ErrorStrings.INVALID_FACT,
		INVALID_STAT  = ErrorStrings.INVALID_STAT,
		METH_DECL     = ErrorStrings.METH_DECL,
		MUL_OP        = ErrorStrings.MUL_OP,
		NO_ARRAY      = ErrorStrings.NO_ARRAY,
		NO_CLASS      = ErrorStrings.NO_CLASS,
		NO_CLASS_TYPE = ErrorStrings.NO_CLASS_TYPE,
		NO_EOF        = ErrorStrings.NO_EOF,
		NO_INT        = ErrorStrings.NO_INT,
		NO_INT_OP     = ErrorStrings.NO_INT_OP,
		NO_MAIN       = ErrorStrings.NO_MAIN,
		NO_PARAMS     = ErrorStrings.NO_PARAMS,
		NO_RETURN     = ErrorStrings.NO_RETURN,
		NO_TYPE       = ErrorStrings.NO_TYPE,
		PARAM_TYPE    = ErrorStrings.PARAM_TYPE,
		PRINT_VALUE   = ErrorStrings.PRINT_VALUE,
		READ_VALUE		= ErrorStrings.READ_VALUE,
		REL_OP        = ErrorStrings.REL_OP,
		RETURN_TYPE   = ErrorStrings.RETURN_TYPE,
		RETURN_VOID   = ErrorStrings.RETURN_VOID,
		VOID_MAIN     = ErrorStrings.VOID_MAIN;
	
	private static final String[] names = Token.names;

	private static PrintWriter out;

	// Sets of starting tokens for some productions.
	private static BitSet firstActPars, firstDecl, firstStat;
	
	// Sets of follow tokens for some productions.
	private static BitSet followDecl, followStat;
	
	/** Last recognized token; */
	private static Token t;
  
	/** Lookahead token (not recognized).) */
	private static Token la;
  
	/** Shortcut to kind attribute of lookahead token (la). */
	private static int sym;

	/** Reads ahead one symbol. */
	private static void scan () {
		/* TODO: add your own code here */
	}
	
	/** Verifies symbol and reads ahead. */
	private static void check (int expected) {
		if (sym == expected) scan();
		else Errors.synError(names[expected] + " expected");
	}

	/** Recovers from parsing error in a global declaration. */
	private static void recoverDecl () {
		/* TODO: add your own code here */
	}

	/** Recovers from parsing error in a statement. */
	private static void recoverStat () {
		/* TODO: add your own code here */
	}

	/** Program = "class" ident { ConstDecl | VarDecl | ClassDecl } 
	 *            "{" { MethodDecl } "}" . */
	private static void Program () {
		/* TODO: add your own code here */
	}

	/* TODO: add further parsing routines here */
	
	/** Starts the analysis. 
	 *	Output is written to System.out.
	 */
	public static void parse () { parse(new PrintWriter(System.out, true)); }
	
	/** Starts the analysis.
	 *  Initializes the parser and all its components.
	 *	Output is written to <code>PrintStream</code> provided in <code>output</code>
	 */
	public static void parse (PrintWriter output) {
		out = output;

		/* TODO: put additional parser start-up code here */
	}
	
	/** Handles all compiler errors. */
	public static class Errors {

		/* TODO: add code to skip error that may be the result of previous errors */
		
		/** Error count. */
		private static int cnt;
		
		public static void synError (String msg) {
			/* TODO: wrap your error skipping code around this */
			out.println("-- line " + la.line + ", col " + la.col + " (SYN): " + msg);
		}
		
		public static void semError (String msg) {
			/* TODO: wrap your error skipping code around this */
			out.println("-- line " + la.line + ", col " + la.col + " (SEM): " + msg);	
		}
		
		public static int count () { return cnt; }
		
		static void init () { cnt = 0; reset(); }
		
		static void reset () {
			/* TODO: add code to stop error skipping here */
		}
	}
}
